#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct Cvor
{
	char *ime;
	int uzrast;
	int broj_igracaka;
	int balans;
	struct Cvor *levi,*desni;
};

typedef struct Cvor cvor; 

int dubina(cvor *p)
{
	int dd=0,dl=0;
	
	if(p)
	{
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dd>dl) return dd++;
		else return dl++;
	}
	else return 0;
}

void levarotacija(cvor **p)
{
	cvor *poml,*pomd;
	poml=(*p);
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	(*p)=pomd;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void desnarotacija(cvor **p)
{
	cvor *poml,*pomd;
	pomd=(*p);
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	(*p)=poml;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void unos(cvor **p)
{
	cvor *pom,*temp;
	pom=(*p);
	char s[20];
	int n,i,u,b;
	printf("Uneti broj dece:\n");
	scanf("%d",&n);
	getchar();
	
	for(i=0;i<n;i++)
	{
		temp=(cvor *)malloc(sizeof(cvor));
		temp->levi=temp->desni=NULL;
		printf("Uneti ime deteta:\n");
		gets(s);
		temp->ime=(char *)malloc(sizeof(char)*(strlen(s)+1));
		strcpy(temp->ime,s);
		printf("Uneti uzrast deteta:\n");
		scanf("%d",&u);
		temp->uzrast=u;
		printf("Uneti broj igracaka:\n");
		scanf("%d",&b);
		temp->broj_igracaka=b;
		getchar();
		dodaj(&pom,temp);
	}
	
	(*p)=pom;
}

int dodaj(cvor **p,cvor *temp)
{
	int rez=0,inkrement;
	cvor *pom;
	pom=(*p);
	
	if(pom==NULL)
	{
		pom=temp;
		pom->balans=0;
		rez=1;
	}
	else
	{
		if((pom->uzrast>temp->uzrast) && (strcmp(pom->ime,temp->ime)>0))
			inkrement=-dodaj(&(pom->levi),temp);
		else inkrement=dodaj(&(pom->desni),temp);
		
		pom->balans=pom->balans+inkrement;
		
		if((pom->balans!=0) && (inkrement!=0))
		{
			if(pom->balans<-1)
			{
				if(pom->levi->balans<0) desnarotacija(&pom);
				else { levarotacija(&(pom->levi)); desnarotacija(&pom); }
			}
			else if(pom->balans>1)
			{
				if(pom->desni->balans>0) levarotacija(&pom);
				else { desnarotacija(&(pom->desni)); levarotacija(pom->levi); }
			}
			else rez=1;
		}
	}
	(*p)=pom;
	return rez;
}

void ispis(cvor *p)
{
	if(p)
	{
		if(p->desni) ispis(p->desni);
		printf("%s  %d  %d\n",p->ime,p->uzrast,p->broj_igracaka);
		if(p->levi) ispis(p->levi);
	}
}

void nadji(cvor *p,int k,int m)
{
	if(p)
	{
		if(k>1)
		{
			if(p->desni) nadji(p->desni,k-1,m);
			if(p->levi) nadji(p->levi,k-1,m);
		}
		if((k==1) && (p->broj_igracaka==m)) printf("%s %d\n",p->ime,p->uzrast);
	}
	
}

main()
{
	cvor *p=NULL;
	int k,m;
	unos(&p);
	ispis(p);
	printf("Uneti zeljeni nivo:\n");
	scanf("%d",&k);
	printf("Uneti zeljeni broj poklona:\n");
	scanf("%d",&m);
	nadji(p,k,m);
}
