#include<stdio.h>
#include<stdlib.h>
#include<string.h>


typedef struct d
{
char ime[10];
int godine,br,balans;
struct d *levi,*desni;
}tree;


#define novi(x) x = (tree *)malloc(sizeof(tree))


tree *form()
{
  tree *k = NULL;

  int i,n,go,br;
  char im[10];

  scanf("%d",&n);
  getchar();

  for(i = 0; i < n; i++)
  {
    fgets(im,10,stdin);
    scanf("%d %d",&go,&br);
    getchar();

    dodaj(&k,go,br,im);
  }
  return k;
}

void lrot(tree **p)
{
  tree *pom1,*pom2;

  pom1 = *p;
  pom2 = pom1->desni;
  pom1->desni = pom2->levi;
  pom2->levi = pom1;
  *p = pom2;

  pom1->balans = dubina(pom1->desni) - dubina(pom1->levi);
  pom2->balans = dubina(pom2->desni) - dubina(pom2->levi);
}


void drot(tree **p)
{
  tree *pom1,*pom2;

  pom1 = *p;
  pom2 = pom1->levi;
  pom1->levi = pom2->desni;
  pom2->desni = pom1;
  *p = pom2;

  pom1->balans = dubina(pom1->desni) - dubina(pom1->levi);
  pom2->balans = dubina(pom2->desni) - dubina(pom2->levi);
}


int dubina(tree *p)
{
int ld=0,dd=0;

 if(p)
 {
   if(p->levi) ld = dubina(p->levi);
   if(p->desni) dd = dubina(p->desni);
   if(ld > dd)
   return ++ld;
   else
   return ++dd;
 }
 else return 0;
}

int dodaj(tree **p, int god,int br, char im[10])
{
   tree *pom = *p;
   int in,rez = 0;

   if(pom == NULL)
   {
    novi(pom);
    pom->balans = 0;
    pom->levi = pom->desni = NULL;
    pom-> br = br;
    pom->godine = god;
    strcpy(pom->ime,im);
    rez = 1;
   }
   else
   {
    if(pom->godine > god) in = -dodaj(&(pom->levi),god,br,im);
    else
    if(pom->godine < god) in = dodaj(&(pom->desni),god,br,im);
    else
    {
    int par = strcmp(pom->ime,im);
    if(par >= 1) in = -dodaj(&(pom->levi),god,br,im);
    else in = dodaj(&(pom->desni),god,br,im);
    }

    pom->balans += in;

    if(in != 0 && pom->balans != 0)
    {
      if(pom->balans < -1){
      if(pom->levi->balans < 0) drot(&pom);
      else { lrot(&(pom->levi)); drot(&pom);}
      }
      else if(pom->balans > 1){
      if(pom->desni->balans > 0) lrot(&pom);
      else { drot(&(pom->desni)); lrot(&pom);}
      }
      else
      rez = 1;
    }
    }
    *p = pom;
    return rez;
}


void stampaj(tree *p)
{
  if (p)
  {
    stampaj(p->desni);
    printf("%s %d\n %d\n %d \n\n",p->ime,p->godine,p->br,p->balans);
    stampaj(p->levi);
  }
}

void izbaci(tree *p, tree **q,int x)
{
  if (p)
  {
    izbaci(p->desni,q,x);
    if(p->godine < x*12) dodaj(q,p->godine,p->br,p->ime);
    izbaci(p->levi,q,x);
  }
}

void stampaj_bez(tree *p,int k, int m, int br)
{
  if (p)
  {
    if((br != k) && (p->br == m))  printf("%s %d\n %d\n\n",p->ime,p->godine,p->br);
    stampaj_bez(p->desni,k,m,br++);
    stampaj_bez(p->levi,k,m,br++);
  }
}

main()
{
tree *a,*q=NULL;
int x;

a = form();
printf("\n");
stampaj(a);


printf("Unesite limit za azuriranje\n");
scanf("%d",&x);
izbaci(a,&q,x);

printf("-------------AZURIRANJE--------------- \n");

stampaj(q);

printf("\nUnesite K i M: \n");
int k,m,br = 1;

scanf("%d %d",&k,&m);

printf("---------Deca koja nisu sa k-tog nivoa i dobila su m poklona----------- \n");

stampaj_bez(a,k,m,1);
}














