#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct dete{
    char ime[30];
    int uzrast,br_igracaka,balans;
    struct dete *levi,*desni;
}Tdrvo;

#define novi(x) x= (Tdrvo*)malloc(sizeof(Tdrvo));

int dubina(Tdrvo *p){
    int dl=0,dd=0;
    if(p){
        if(p->levi) dl = dubina(p->levi);
        if(p->desni) dd = dubina(p->desni);
        if(dl>dd)
            return ++dl;
        else
            return ++dd;
    } else
        return 0;
}

void lrotacija(Tdrvo **p){
    Tdrvo *poml,*pomd;
    poml=*p;
    pomd = poml->desni;
    poml->desni = pomd->levi;
    pomd->levi = poml;
    *p = pomd;
    poml->balans = dubina(poml->desni)-dubina(poml->levi);
    pomd->balans = dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(Tdrvo **p){
    Tdrvo *poml,*pomd;
    pomd=*p;
    poml = pomd->levi;
    pomd->levi = poml->desni;
    poml->desni = pomd;
    *p = poml;
    poml->balans = dubina(poml->desni)-dubina(poml->levi);
    pomd->balans = dubina(pomd->desni)-dubina(pomd->levi);
}

int dodaj(Tdrvo **p,char *ime,int u,int b){
    int rezultat = 0,inkrement;
    Tdrvo *pom;
    pom = *p;
    if(!pom){
        novi(pom);
        strcpy(pom->ime,ime);
        pom->uzrast = u;
        pom->br_igracaka = b;
        pom->balans = 0;
        pom->levi = pom->desni = NULL;
        rezultat = 1;
    } else {
        if(u<pom->uzrast) inkrement = -dodaj(&(pom->levi),ime,u,b);
        else if (u>pom->uzrast) inkrement = dodaj(&(pom->desni),ime,u,b);
        else {
            if(strcmp(ime,pom->ime)<0)
                inkrement = -dodaj(&(pom->levi),ime,u,b);
            else
                inkrement = dodaj(&(pom->desni),ime,u,b);
            pom->balans != inkrement;
            if(inkrement && pom->balans){
                if(pom->balans < -1){
                    if(pom->levi->balans < 0)
                        drotacija(&pom);
                    else {
                        lrotacija(&(pom->levi));
                        drotacija(&pom);
                    }
                } else if(pom->balans > 1){
                    if(pom->desni->balans > 0)
                        lrotacija(&pom);
                    else {
                        drotacija(&(pom->desni));
                        lrotacija(&pom);
                    }
                } else rezultat = 1;
            }
        }
    }
    *p = pom;
    return rezultat;
}

Tdrvo *form(){
    Tdrvo *p = NULL;
    char ime[30];
    int k,u,b;
    scanf("%d",&k);
    while(k--){
      //  printf("Ime: ");
        scanf("%s",ime);
       // printf("uzrast ");
        scanf("%d",&u);
       // printf("Broj igracaka: ");
        scanf("%d",&b);
        dodaj(&p,ime,u,b);
    }
    return p;
}

void ispis(Tdrvo *p){
    if(p){
        if(p->desni)  ispis(p->desni);
        printf("%s\t%d\t%d\n",p->ime,p->uzrast,p->br_igracaka);
        if(p->levi)  ispis(p->levi);
    }
}

void form_new(Tdrvo *p,Tdrvo **q,int x){
    int brg;
    if(p){
        if(p->levi) form_new(p->levi,q,x);
        if(p->desni) form_new(p->desni,q,x);
        brg = p->uzrast/12 + 1;
        if(brg<x)
            dodaj(q,p->ime,p->uzrast,p->br_igracaka);
    }
}

void ispis_k(Tdrvo *p,int k,int m,int nivo){
    if(p){
        if(nivo < k){
            if(p->desni)
                ispis_k(p->desni,k,m,nivo+1);
            if(p->levi)
                ispis_k(p->levi,k,m,nivo+1);
        } else if (nivo == k)
            if(p->br_igracaka==m)
                printf("%s\t%d\t%d\n",p->ime,p->uzrast,p->br_igracaka);
    }
}

main(){
    Tdrvo *p,*novi=NULL;
    p=form();
    ispis(p);
    int x;
   // printf("Unesite x godina: ");
    scanf("%d",&x);
    form_new(p,&novi,x);
    printf("Novi raspored\n");
    ispis(novi);
    int k,m;
    //printf("Unesite nivo: ");
    scanf("%d",&k);
   // printf("Unesite broj poklona: ");
    scanf("%d",&m);
    if(dubina(novi)>k){
        printf("Deca na nivou %d, koja su dobila %d poklona su: \n",k,m);
        ispis_k(novi,k,m,0);
    } else printf("Nemate podatke o deci na nivou %d\n",k);
}










