#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct DETE
{
	char *ime;
	int uzrast;
	int broj_igracaka;
};

struct drvo 
{
	struct DETE *podatak;
	int balans;
	struct drvo *levi,*desni;
};
#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo))
void form(struct drvo **p);
int dodaj(struct drvo **p,struct DETE *q);
int dubina(struct drvo *p);
void lrotacija(struct drvo **p);
void drotacija(struct drvo **p);
void Ispis(struct drvo *p);
struct DETE* ucitajDETE();
void Stampajnivok(struct drvo *p,int m,int k);
int nivo(struct drvo *p);

struct DETE* ucitajDETE()
{
	struct DETE *q;
	getchar();
	q=(struct DETE *)malloc(sizeof(struct DETE));
	char s[50];
	printf("Ime: "); scanf("%s",s);
	q->ime=(char *)malloc(sizeof(char));
	strcpy(q->ime,s);
	printf("Uzrast u mesecima: "); scanf("%d",&q->uzrast);
	printf("Broj igracaka: "); scanf("%d",&q->broj_igracaka);
	return q;
}

int dodaj(struct drvo **p,struct DETE *q)
{
	int inkrement,rezultat=0;
	struct drvo *t=*p;
	if(t==NULL)
	{
		novi(t);
		if(t==NULL)
		{
			printf("Greska\n");
			exit(0);
		}
		t->levi=t->desni=NULL;
		t->podatak=q;
		t->balans=0;
		rezultat=1;
	}
	else
	{
		if(((q->uzrast>t->podatak->uzrast) || (q->ime > t->podatak->ime))||((q->uzrast = t->podatak->uzrast) || (q->ime = t->podatak->ime))) inkrement=dodaj(&(t->desni),q);
		else inkrement=-dodaj(&(t->levi),q);
		t->balans+=inkrement;
		if(inkrement!=0 && t->balans!=0)
		{
			if(t->balans<-1) 
			{
				if(t->levi->balans<0) drotacija(&t);
				else {lrotacija(&(t->levi)); drotacija(&t);}
			}
			else if(t->balans>1)
			{
				if(t->desni->balans>0) lrotacija(&t);
				else{drotacija(&(t->desni)); lrotacija(&t);}
			}
			else rezultat=1;
		}		
	}
	*p=t;
	return rezultat;
}

void form(struct drvo **p)
{
	struct DETE *q;
	int n,i;
	printf("Broj dece:\n"); scanf("%d",&n);
	for(i=0;i<n;i++)
	{
		q=ucitajDETE();
		dodaj(p,q);
	}
}

int dubina(struct drvo *p)
{
	int dd=0,dl=0;
	if(p)
	{
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dd>dl) return ++dd;
		else return ++dl;
	}else return 0;
}	
	
void lrotacija(struct drvo **p)
{
	struct drvo *poml,*pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}
			
void drotacija(struct drvo **p)
{
	struct drvo *poml,*pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void Ispis(struct drvo *p)
{
	if(p)
	{
		Ispis(p->desni);
		printf("Ime: %s",p->podatak->ime);
		printf("Uzrast: %d",p->podatak->uzrast);
		printf("Broj Igracaka: %d",p->podatak->broj_igracaka);
		Ispis(p->levi);
	}
	printf("\n");
}

void Stampajnivok(struct drvo *p,int m,int k)
{
	if(p)
	{
		Ispis(p->desni);
		int n=nivo(p->desni);
		if((p->podatak->broj_igracaka==m)&&(n==k))
		{
			printf("Ime: %s",p->podatak->ime);
			printf("Uzrast: %d",p->podatak->uzrast);
		}
		Ispis(p->levi);
	}
}

int nivo(struct drvo *p)
{
	int nl=1,nd=1;
	if(p)
	{
		
		if(p->levi) nl+=nivo(p->levi);
		if(p->desni) nd+=nivo(p->desni);
		if(nl>nd) return nl;
		else return nd;
	}else return 0;
}

main()
{
	struct drvo *p=NULL;
	form(&p);
	Ispis(p);
	int k,m;
	printf("M: "); scanf("%d",&m);
	printf("K: "); scanf("%d",&k);
	Stampajnivok(p,m,k);
	printf("\n");
}

