#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum{crvena,crna};
struct stablo{
	char ime[30];
	int meseci;
	int broj_igracaka;
	int boja;
	struct stablo *roditelj,*levi,*desni;
};

#define novi(x) x=(struct stablo*)malloc(sizeof(struct stablo))

void lrotacija(struct stablo **t){
	struct stablo *x,*y;
	x=*t;
	y=x->desni;
	x->desni=y->levi;
	if(y->levi) y->levi->roditelj=x;
	y->roditelj=x->roditelj;
	if(x->roditelj)
		if(x==x->roditelj->levi) x->roditelj->levi=y;
	else x->roditelj->desni=y;
	y->levi=x;
	x->roditelj=y;
	*t=y;
}

void drotacija(struct stablo **t){
	struct stablo *x,*y;
	y=*t;
	x=y->levi;
	y->levi=x->desni;
	if(x->desni) x->desni->roditelj=y;
	x->roditelj=y->roditelj;
	if(y->roditelj)
		if(y==y->roditelj->levi) y->roditelj->levi=x;
	else y->roditelj->desni=x;
	x->desni=y;
	y->roditelj=x;
	*t=x;
}

void bojefix(struct stablo **p,struct stablo *z){
	struct stablo *y,*t;
	while((z->roditelj) && (z->roditelj->boja==crvena)){
		if(z->roditelj==z->roditelj->roditelj->levi){
			y=z->roditelj->roditelj->desni;
			if((y) && (y->boja==crvena)){
				z->roditelj->boja=crna;
				y->boja=crna;
				z->roditelj->roditelj->boja=crvena;
				z=z->roditelj->roditelj;
			}
			else{
				if(z==z->roditelj->desni){
					z=z->roditelj;
					lrotacija(&z);
					if(!z->roditelj) *p=z;
					z=z->levi;
				}
				z->roditelj->boja=crna;
				z->roditelj->roditelj->boja=crvena;
				t=z->roditelj->roditelj;
				drotacija(&t);
				if(!t->roditelj) *p=t;
			}
		}
		else{
			y=z->roditelj->roditelj->levi;
			if((y) && (y->boja==crvena)){
				z->roditelj->boja=crna;
				y->boja=crna;
				z->roditelj->roditelj->boja=crvena;
				z=z->roditelj->roditelj;
			}
			else{
				if(z==z->roditelj->levi){
					z=z->roditelj;
					drotacija(&z);
					if(!z->roditelj) *p=z;
					z=z->desni;
				}
				z->roditelj->boja=crna;
				z->roditelj->roditelj->boja=crvena;
				t=z->roditelj->roditelj;
				lrotacija(&t);
				if(!t->roditelj) *p=t;
			}
			
		}
	}
	(*p)->boja=crna;
}

void dodaj(struct stablo **koren,struct stablo *cvor){
	
	struct stablo *x,*y;
	x=*koren;
	y=NULL;
	while(x){
		
		y=x;
		if(((cvor->meseci) > (x->meseci)) && (strcmp(cvor->ime,x->ime)==1)) x=x->levi;
		else x=x->desni;
	}
	cvor->roditelj=y;
	if(!y) *koren=cvor;
	else{
		if(((cvor->meseci) > (y->meseci)) && ((strcmp(cvor->ime,y->ime)==1))) y->levi=cvor;
		else y->desni=cvor;
	}
	bojefix(koren,cvor);
}

struct stablo *form(){

	struct stablo *koren=NULL,*cvor;
	char ime[30];
	int n,i;
	int broj_igracaka,meseci;
	scanf("%d",&n);
	for (i = 0; i < n; i++)
	{
		novi(cvor);
		scanf("%s",ime);
		scanf("%d",&meseci);
		scanf("%d",&broj_igracaka);
		cvor->levi=cvor->desni=NULL;
		cvor->boja=crvena;
		strcpy(cvor->ime,ime);
		cvor->meseci=meseci;
		cvor->broj_igracaka=broj_igracaka;
		dodaj(&koren,cvor);
	}
}



void ispis(struct stablo *koren){
	if(koren){
		ispis(koren->levi);
		printf("Ime: %s",koren->ime);
		printf("Meseci: %d",koren->meseci);
		printf("Broj_igracaka: %d",koren->broj_igracaka);
		if(koren->boja==crvena) printf("(crvena)\n");
		else printf("(crna)\n");
		ispis(koren->desni);
	}
}

int brisi(struct stablo **p,struct stablo *q,int x){
	struct stablo *pom;
	if(q!=NULL)
	if(q->meseci>x){
		novi(pom);
		pom->ime=q->ime;
		pom->meseci=q->meseci;
		pom->broj_igracaka=q->broj_igracaka;
		pom->boja=crvena;
		pom->roditelj=pom->levi=pom->desni=NULL;
		dodaj(p,pom);
		brisi(p,q->levi,x);
		brisi(p,q->desni,x);
	}
	else return;
}

int main(){
	struct stablo *koren,*t,*b=NULL;
	int x;
	scanf("%d",&x);
	koren=form();
	ispis(koren);
	brisi(&b,t,x);
	ispis(b);
	return 0;
}
