#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct Dete
{
	char ime[10];
	int uzrast;
	int broji;
	int balans;
	struct Dete *levi;
	struct Dete *desni;
}dete;

#define novi(x) x=(dete*)malloc(sizeof(dete))

int dubina(dete *k)
{
	if(k)
	{
		int dd=0,dl=0;

		if(k->levi) dl=dubina(k->levi);
		if(k->desni) dd=dubina(k->desni);
		
		if(dd<dl) return ++dl;
		else return ++dd;
	}
}

void lrotacija(dete **k)
{
	dete *pomd,*poml;
	
	poml=*k;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*k=pomd;

	pomd->balans=dubina(pomd->desni) - dubina(pomd->levi);
	poml->balans=dubina(poml->desni) - dubina(poml->levi);
}

void drotacija(dete **k)
{
	dete *pomd,*poml;
	
	pomd=*k;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*k=poml;

	pomd->balans=dubina(pomd->desni) - dubina(pomd->levi);
	poml->balans=dubina(poml->desni) - dubina(poml->levi);
}

void ispis(dete *k)
{
	if(k)
	{
		if(k->desni) ispis(k->desni);
		printf("%s  ",k->ime);
		printf("uzrast: %d  ",k->uzrast);
		printf("igracke: %d \n",k->broji);
		if(k->levi) ispis(k->levi);
	}
}

int dodaj(dete **k,char ime[],int uzrast,int broji)
{
	int rezultat=0,inkrement;
	dete *pom;
	pom=*k;
	
	if(pom==NULL)
	{
		novi(pom);
		strcpy(pom->ime,ime);
		pom->uzrast=uzrast;
		pom->broji=broji;
		pom->balans=0;
		pom->levi=pom->desni=NULL;
		rezultat = 1;
	}
	else
	{
		if(uzrast<pom->uzrast) inkrement=-dodaj(&(pom->levi),ime,uzrast,broji);
		else if (uzrast>pom->uzrast) inkrement=dodaj(&(pom->desni),ime,uzrast,broji);
		else if (strcmp(ime,pom->ime)<0) inkrement=-dodaj(&(pom->levi),ime,uzrast,broji);
		else inkrement=dodaj(&(pom->desni),ime,uzrast,broji);
	
		pom->balans += inkrement;

		if(inkrement!=0 && pom->balans!=0)
		{
			if(pom->balans < -1)
			{
				if(pom->levi->balans < 0) drotacija(&pom);
				else { lrotacija(&(pom->levi)); drotacija(&pom); }
			}
			else if(pom->balans > 1)
			{
				if(pom->desni->balans > 0) lrotacija(&pom);
				else { drotacija(&(pom->desni)); lrotacija(&pom); }
			}
		rezultat = 1;
		}
	}
	*k=pom;
	return rezultat;
}

dete *form()
{
	dete *k;
	k=NULL;
	int n,i,broji,uzrast;
	char ime[10];
	
	printf("Unesi n : ");
	scanf("%d",&n);
	
	for(i=0;i<n;i++)
	{
		printf("Unesi ime ");
		scanf("%s",ime);
		printf("Unesi uzrast ");
		scanf("%d",&uzrast);
		printf("Unesi broj igracaka ");
		scanf("%d",&broji);
		
		dodaj(&k,ime,uzrast,broji);
	}

	return k;
}

void brisi(dete *k,dete **k1,int x)
{
	if(k)
	{
		if(k->desni) brisi(k->desni,k1,x);
		
		if(k->levi) brisi(k->levi,k1,x);

		if(k->uzrast/12<x) dodaj(k1,k->ime,k->uzrast,k->broji);
	}
}

void stampanje(dete *k,dete *k1,int n,int m)
{
	
	if(k)
	{
		if(k->desni) stampanje(k->desni,k1,n,m);
		
		if(k->levi) stampanje(k->levi,k1,n,m);

		if((dubina(k1)-dubina(k)+1==n) && (k->broji==m)) 
		{
			printf("%s  ",k->ime);
			printf("uzrast: %d  ",k->uzrast);
		}
	}
}

main()
{
	dete *k,*k1;
	k1=NULL;
	int x,n,m;
	
	k=form();
	
	ispis(k);

	printf("Unesi x : ");
	scanf("%d",&x);

	brisi(k,&k1,x);

if(k1)
{

	ispis(k1);

	printf("Unesi nivo K: ");
	scanf("%d",&n);
	printf("Unesi broj poklona M: ");
	scanf("%d",&m);

	stampanje(k,k,n,m);
}

else printf("Nema vise dece! \n");
	
}



































