#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct dete
{
	char ime[30];
	int uzrast;
	int broj_igracaka;
	int balans;
	struct dete *levi,*desni;
}dete;

#define novi(x) x=(dete*)malloc(sizeof(dete))


void ispis(dete *p);
int dubina(dete *p);
void lrotacija(dete **p);
void drotacija(dete **p);
dete *form( int n);
int dodaj(dete **p,char ime[],int uzrast,int broj_igracaka);
dete *nadji(dete **p);
void sredi(dete **p);
dete *obrisi_b(dete *p,int y);
void koliko_ima(dete *p,int y, int *br);
void azuriran_ispis(dete *p);
void nivo_k(dete *p,int k,int m,int *brojac);



int main()
{
	
	dete* p=NULL;
	
	int n;//broj dece
	
	scanf("%d",&n);
	
	p=form(n);
	
	ispis(p);
	
	
	int x; //broj godina
	
	printf("Uneste broj godina x\n");
	scanf("%d",&x);
	int y;
	y=x*12; //y saljem funkciji obrisi_b
	
	
	int br=0; //koliko ima dece koja su starija od y meseci
	
	koliko_ima(p,y,&br);
	
	printf("Ima ih %d\n",br);
	
	int i;
	
	for(i=0; i<br; i++) obrisi_b(p,y);
	
	azuriran_ispis(p);
	
	int k,m;
	int brojac=0;
	
	printf("Unesite nivo k\n");
	scanf("%d",&k);
	
	printf("Unesite broj poklona\n");
	scanf("%d",&m);
	
	nivo_k(p,k,m,&brojac);
	
	
	
	
	return 0;
}


void nivo_k(dete *p,int k,int m,int *brojac)
{
	
	if(p)
	{
		(*brojac)++;
		//printf("vrednost za br je %d\n",*(brojac));
		if(p->levi) nivo_k(p->levi,k,m,brojac);
		//printf("p->ime je %s\n",p->ime);
		//printf("k je %d,brojac je %d,m je %d,p->broj_poklona je %d",k,*(brojac),m,p->broj_igracaka);
			if(k==(*brojac) && (m==p->broj_igracaka)) printf("Ime %s\t,uzrast %d\n",p->ime,p->uzrast);
		(*brojac)--;
		if(p->desni) nivo_k(p->desni,k,m,brojac);
	}
}

void azuriran_ispis(dete *p)
{
	if(p)
	{
		azuriran_ispis(p->desni);
		printf("Ime deteta je %s\t, njegov uzrast %d\t, a broj poklona %d",p->ime,p->uzrast+12,p->broj_igracaka);
		printf("\n");
		azuriran_ispis(p->levi);
	}
}



void koliko_ima(dete *p,int y, int *br)
{
	if(p)
	{
		if(p->levi)  koliko_ima(p->levi,y,br);
			if(p->uzrast > y ) (*br)++;
		if(p->desni) koliko_ima(p->desni,y,br);

	}
}



void ispis(dete *p)
{
	if(p)
	{
		ispis(p->desni);
		printf("Ime deteta je %s\t, njegov uzrast %d\t, a broj poklona %d",p->ime,p->uzrast,p->broj_igracaka);
		printf("\n");
		ispis(p->levi);
	}
}

int dubina(dete *p)
{
	int dl=0, dd=0;
	if(p)
	{
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		
		if(dl > dd) return ++dl;
		else return ++dd;
	}
	else return 0;
}

//leva
void lrotacija(dete **p)
{
	dete *poml, *pomd;
	
	poml=*p;
	pomd=poml->desni;
	
	poml->desni=pomd->levi;
	pomd->levi=poml;
	
	*p=pomd;
	
	//azuriranje balansa
	
	poml->balans=dubina(poml->desni) - dubina(poml->levi);
	pomd->balans=dubina(pomd->desni) - dubina(pomd->levi);
	
}

void drotacija(dete **p)
{
	dete *poml,*pomd;
	
	pomd=*p;
	poml=pomd->levi;
	
	pomd->levi=poml->desni;
	poml->desni=pomd;
	
	*p=poml;
	
	//azuriranje balansa
	
	poml->balans=dubina(poml->desni) - dubina(poml->levi);
	pomd->balans=dubina(pomd->desni) - dubina(pomd->levi);
}


dete *form( int n)
{
	dete *p=NULL;
	
	char ime[50];
	int uzrast;
	int broj_igracaka;
	
	int i;
	
	for(i=0; i<n; i++)
	{
		scanf("%s",ime);
		scanf("%d",&uzrast);
		scanf("%d",&broj_igracaka);
		
		dodaj(&p,ime,uzrast,broj_igracaka);
	}
	
	
	return p;
}




int dodaj(dete **p,char ime[],int uzrast,int broj_igracaka)
{
	int inkrement,rezultat=0;
	
	dete *t=*p;
	
	if(t==NULL)
	{
		novi(t);
		if(t==NULL)
		{
			printf("Losa alokacija\n");
			exit(0);
		}
		strcpy(t->ime,ime);
		t->uzrast=uzrast;
		t->broj_igracaka=broj_igracaka;
		t->levi=t->desni=NULL;
		t->balans=0;
		rezultat=1;
	}
	else
	{
		if(uzrast > t->uzrast) inkrement=dodaj(&(t->desni),ime,uzrast,broj_igracaka);
		else if((uzrast==t->uzrast) && (strcmp(ime,t->ime)>=0)) inkrement=dodaj(&(t->desni),ime,uzrast,broj_igracaka);
		else inkrement=-dodaj(&(t->levi),ime,uzrast,broj_igracaka);
		
		t->balans+=inkrement;
		
		if(inkrement !=0 && t->balans !=0)
		{
			if(t->balans < -1)
			{
				if(t->levi->balans < 0 ) drotacija(&t);
				else { lrotacija(&(t->levi)); drotacija(&t); }
			}
			else if(t->balans > 1 )
			{
				if(t->desni > 0 ) lrotacija(&t);
				else { drotacija(&(t->desni)); lrotacija(&t); }
			}
			else rezultat=1;
		}
	}
*p=t;
return rezultat;
}



dete *nadji(dete **p)
{
	dete *pom=*p;
	dete *rez;
	
	if(!pom->levi)
	{
		rez=pom;
		pom=pom->desni;
	}
	else rez=nadji(&(pom->levi));
	
	
	if(pom)
	{
		pom->balans=dubina(pom->desni) - dubina(pom->levi);
		sredi(&pom);
	}
	
	*p=pom;
	return rez;
}


void sredi(dete **p)
{
	dete *t;
	
	if(*p)
	{
		*p=t;
		
		if(t->balans < -1 )
		{
			if(t->levi->balans < 0 ) drotacija(&t);
			else { lrotacija(&(t->levi)); drotacija(&t); }
		}
		else if(t->balans > 1 )
		{
			if(t->desni->balans > 0) lrotacija(&t);
			else { drotacija(&(t->desni)); lrotacija(&t); }
		}
	}
	*p=t;
}



dete *obrisi_b(dete *p,int y)
{
	dete *pom;
	dete *pomocna;
	
	if(!p) return NULL;
	
	if(p->uzrast > y)
	{
		if((!p->levi) && (!p->desni))
		{
			free(p);
			return NULL;
		}
		if((!p->levi) && (p->desni))
		{
			pom=p->desni;
			free(p);
			return pom;
		}
		if((p->levi) && (!p->desni))
		{
			pom=p->levi;
			free(p);
			return pom;
		}
		if((p->levi) && (p->desni))
		{
			pomocna=nadji(&(p->desni));
			strcpy(p->ime,pomocna->ime);
			p->uzrast=pomocna->uzrast;
			p->broj_igracaka=pomocna->broj_igracaka;
			
			p->balans=dubina(p->desni) - dubina(p->levi);
			sredi(&p);
		}

	}
	
	
if(y < p->uzrast)
{
	p->levi=obrisi_b(p->levi,y);
	p->balans=dubina(p->desni) - dubina(p->levi);
	sredi(&p);
	return p;
}
else
{
	p->desni=obrisi_b(p->desni,y);
	p->balans=dubina(p->desni) - dubina(p->levi);
	return p;
}

}

		

		
		
