#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct drvo
{
	char ime[20];
	int uzrast;
	int broj;
	int balans;
	struct drvo *levi,*desni;
};

#define novi(x) x = (struct drvo*)malloc(sizeof(struct drvo))

void ispis(struct drvo *);
void lrotacija(struct drvo**);
void drotacija(struct drvo**);
int dodaj(struct drvo **,char*,int,int);//----------------------
struct drvo *form(int);
int dubina(struct drvo*);

void obrisi(struct drvo *,struct drvo **,int );


int main()
{
	struct drvo *p;
	//struct drvo *q;
	int n;
	printf("Unesite broj dece:\n");
	scanf("%d",&n);
	//getchar();
	p = form(n);
	putchar('\n');
	ispis(p);
	putchar('\n');
	/*printf("Unesite x:\n");
	int x;
	scanf("%d",&x);
	struct drvo *q;
	q = NULL;
	obrisi(p,&q,x);
	ispis(q);
	putchar('\n');*/
	return 0;
}

void ispis(struct drvo *p)
{
	if(p)
	{
		if(p->levi) ispis(p->levi);
		printf("%s %d %d %d\n",p->ime,p->uzrast,p->broj,p->balans);
		if(p->desni) ispis(p->desni);
	}
}

void lrotacija(struct drvo ** t)
{
	struct drvo *poml,*pomd;
	poml = *t;
	pomd = poml->desni;
	poml->desni = pomd->levi;
	pomd->levi = poml;
	*t = pomd;
	
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

void drotacija(struct drvo ** t)
{
	struct drvo *poml,*pomd;
	pomd = *t;
	poml = pomd->levi;
	pomd->levi = poml->desni;
	poml->desni = pomd;
	*t = poml;
	
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

int dubina(struct drvo *p)
{
	int dd = 0, dl = 0;
	if(p)
	{
		if(p->levi) dl = dubina(p->levi);
		if(p->desni) dd = dubina(p->desni);
		if (dl > dd) return ++dl;
		else return ++dd;
	}
	else return 0;
}

int dodaj(struct drvo **p,char ime[20],int uzrast,int broj)
{
	struct drvo *t;
	int inkrement,rezultat;
	t = *p;
	rezultat = 0;
	if(t == NULL)
	{
		novi(t);
		if(t == NULL)
		{
			printf("Greska pri alokaciji memorije.\n");
			exit(0);
		}
		t->balans = 0;
		t->levi = t->desni = NULL;
		strcpy(t->ime,ime);
		t->uzrast = uzrast;
		t->broj = broj;
		rezultat = 1;
	}
	else
	{
		if( uzrast < t->uzrast) inkrement = -dodaj(&(t->desni),ime,uzrast,broj);
		else if(strcmp(t->ime,ime) > 0) inkrement = -dodaj(&(t->desni),ime,uzrast,broj);
		else if((strcmp(t->ime,ime) == 0) && (uzrast == t->uzrast)) inkrement = -dodaj(&(t->desni),ime,uzrast,broj);
				else inkrement = dodaj(&(t->levi),ime,uzrast,broj);
		t->balans += inkrement;
		if(t->balans != 0 && inkrement != 0)
		{
			if(t->balans < -1)
			{
				if(t->levi->balans < 0) drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else if(t->balans > 1)
			{
				if(t->desni->balans > 0) lrotacija(&t);
				else
				{
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			}
			else rezultat = 1;
		}
	}
	*p = t;
	return rezultat;
}

struct drvo *form(int n)
{
	struct drvo *koren;
	char ime[20];
	int uzrast;
	int broj;
	int i;
	koren = NULL;
	
	for(i = 0;i < n;i ++)
	{
		printf("Unesite ime:\n");
		scanf("%s",ime);
		printf("Unesite uzrast:\n");
		scanf("%d",&uzrast);
		printf("Unesite broj poklona:\n");
		scanf("%d",&broj);
		dodaj(&koren,ime,uzrast,broj);
	}
	return koren;
}
/*
void obrisi(struct drvo *p,struct drvo **q,int x)
{
	if(p)
	{
		if(p->levi) obrisi(p->levi,q,x);
		if(p->uzrast/12 > x) dodaj(q,p->ime,p->uzrast,p->broj);
		if(p->desni) obrisi(p->desni,q,x);
		
	}
}
*/
