#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum{CRVENA,CRNA};

struct drvo
{
	char *ime;
	int uzrast;
	int igracke;
	int boja;
	struct drvo *levi,*desni,*roditelj;
};

typedef struct drvo deca;
#define novi(x) x=(deca *)malloc(sizeof(deca));
//=====================================================//
void lrotacija(deca **p)
{
	deca *pom,*pom1;
	pom=*p;
	pom1=pom->desni;
	pom->desni=pom1->levi;
	if(pom1->levi) pom1->roditelj->levi=pom;
	pom1->roditelj=pom->roditelj;
	if(pom->roditelj)
			if(pom == pom->roditelj->levi) pom->roditelj->levi=pom1;
			else pom->roditelj->desni=pom1;
			pom1->levi=pom;
			pom->roditelj=pom1;
			*p=pom1;
}
//=====================================================//
void drotacija(deca **p)
{
	deca *pom,*pom1;
	pom=*p;
	pom1=pom->levi;
	pom->levi=pom1->desni;
	if(pom1->desni) pom1->roditelj->desni=pom;
	pom1->roditelj=pom->roditelj;
	if(pom->roditelj)
			if(pom == pom->roditelj->desni) pom->roditelj->desni=pom1;
			else pom->roditelj->levi=pom1;
			pom1->desni=pom;
			pom->roditelj=pom1;
			*p=pom1;
}
//=====================================================//
void bojefix(deca **p,deca *z)
{
	deca *y,*t;
	while((z->roditelj) && (z->roditelj->boja == CRVENA))
	{
		if((z->roditelj) == (z->roditelj->roditelj->levi))
		{
			y=z->roditelj->roditelj->desni;
			if((y) && (y->boja == CRNA))
			{
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				z=z->roditelj->roditelj;
			}
			else
			{
				if(z == z->roditelj->desni)
				{
					z=z->roditelj;
					lrotacija(&z);
					if(!z->roditelj) *p=z;
					z=z->levi;
				}
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				t=z->roditelj->roditelj;
				drotacija(&t);
				if(!t->roditelj) *p=t;
			}
		}
		else
		{
			y=z->roditelj->roditelj->levi;
			if((y) && (y->boja == CRNA))
			{
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				z=z->roditelj->roditelj;
			}
			else
			{
				if(z == z->roditelj->levi)
				{
					z=z->roditelj;
					drotacija(&z);
					if(!z->roditelj) *p=z;
					z=z->desni;
				}
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				t=z->roditelj->roditelj;
				lrotacija(&t);
				if(!t->roditelj) *p=t;
			}
		}
	}
	(*p)->boja = CRNA;
}

//=====================================================//
void dodaj(deca **p,deca *z)
{
	deca *pom,*pom1;
	pom=*p;
	pom1=NULL;
	while(pom!=NULL)
	{
		pom1=pom;
		if(z->uzrast < pom->uzrast) pom=pom->desni;
		else
		{
			if(z->uzrast == pom->uzrast) 
			{
				if(strcmp(z->ime,pom->ime)==0) pom=pom->desni;
				else pom=pom->levi;
			}
			else pom=pom->levi;
		}
		z->roditelj=pom1;
		if(!pom1)
		*p=z;
		if(z->uzrast < pom1->uzrast) pom1->desni=z;
		else
		{
			if(z->uzrast == pom1->uzrast) 
			{
				if(strcmp(z->ime,pom1->ime)==0) pom1->desni=z;
				else pom1->levi=z;
			}
			else pom1->levi=z;
		}
		bojefix(p,z);
	}
}
//=====================================================//
deca *form()
{
	deca *p=NULL,*z;
	char ime[100];
	int uzrast,n,i,igracke;
	printf("uneti broj dece: ");
	scanf("%d",&n);
	
	for(i=0;i<n;i++)
	{
		printf("uneti ime: ");
		scanf("%s",ime);
		printf("uneti uzrast deteta: ");
		scanf("%d",&uzrast);
		printf("uneti broj igracaka: ");
		scanf("%d",&igracke);
		novi(z);
		z->levi=z->desni=z->roditelj=NULL;
		z->ime=(char *)malloc(strlen(ime)+1);
		strcpy(z->ime,ime);
		z->uzrast=uzrast;
		z->igracke=igracke;
		z->boja=CRVENA;
		dodaj(&p,z);
	}
	return p;
}
//=====================================================//
void ispis(deca *p)
{
	while(p!=NULL)
	{
		ispis(p->levi);
		printf("%s\t%d\t%d\t",p->ime,p->uzrast,p->igracke);
		if(p->boja == CRVENA) printf("CRVENA");
		else printf("CRNA");
		ispis(p->desni);
	}
	printf("\n");
}
//=====================================================//
main()
{
	deca *p=NULL;
	p=form();
	ispis(p);
}
